//
//  B7PlugIn.h
//  Watchmac
//
//  Created by Georg C. on 27.10.08.
//  Copyright 2008 bloo7 (Georg C. Brückmann). All rights reserved.
//WMDummySensor


@class B7PlugInManager;
@class NSImage;


@interface B7PlugIn : NSObject {
	NSBundle				*bundle;
	B7PlugInManager	*plugInManager;
}

@property(readonly, retain)	NSBundle				*bundle;
@property(readwrite, assign)	B7PlugInManager	*plugInManager;
@property(readwrite, copy)		NSDictionary		*userDefaults;
@property(readonly, assign,
	getter=isBuiltIn)				BOOL					builtIn;
@property(readonly, copy)		NSString				*name;

- (id)initWithBundle:(NSBundle *)theBundle plugInManager:(B7PlugInManager *)theManager;

- (void)releaseResources;

/* Only available if AppKit is loaded. */
- (NSImage *)plugInImageNamed:(NSString *)theName;

- (id)objectForUserDefaultsKey:(NSString *)theKey;
- (void)setObject:(id)theObject forUserDefaultsKey:(NSString *)theKey;

@end
