//
//  B7PlugInManager.h
//  Watchmac
//
//  Created by Georg C. on 27.10.08.
//  Copyright 2008 bloo7 (Georg C. Brückmann). All rights reserved.
//WMDummySensor


@class B7PlugIn;
@class B7PlugInManager;


@protocol B7PlugInManagerDelegate <NSObject>

@optional
- (BOOL)plugInManager:(B7PlugInManager *)thePlugInManager shouldLoadPlugInAtPath:(NSString *)thePlugInFilename;
- (BOOL)plugInManager:(B7PlugInManager *)thePlugInManager shouldLoadPlugInAtPathAfterFailedVerification:(NSString *)thePlugInFilename;
- (void)plugInManager:(B7PlugInManager *)thePlugInManager didLoadPlugIn:(B7PlugIn *)thePlugIn;
- (void)plugInManager:(B7PlugInManager *)thePlugInManager loadingPlugInAtPath:(NSString *)thePlugInFilename failedWithError:(NSError *)theError;
- (BOOL)plugInManager:(B7PlugInManager *)thePlugInManager shouldTrust:(BOOL)shouldTrust plugIn:(B7PlugIn *)thePlugIn;

@end


@interface B7PlugInManager : NSObject {
	NSMutableSet			*loadedPlugIns;
	BOOL						verifiesCodeSignatures;
	__weak id				delegate;
	NSMutableDictionary	*allPlugInMetadata;
	NSString					*certificateAuthoritySHA1Hash;
}

@property(readonly, copy)		NSSet			*loadedPlugIns;
@property(readwrite, assign)	BOOL			verifiesCodeSignatures;
@property(readwrite, assign)	__weak id	delegate;
@property(readwrite, copy)		NSString		*certificateAuthoritySHA1Hash;

+ (B7PlugInManager *)defaultManager;
+ (Class)plugInBaseClass;

- (NSSet *)loadPlugIns:(NSSet *)theFileExtensions fromDirectories:(NSArray *)theDirectories;
- (B7PlugIn *)loadPlugInAtPath:(NSString *)thePlugInFilename;

- (NSSet *)plugInsOfClass:(Class)theClass;
- (B7PlugIn *)plugInWithIdentifier:(NSString *)theIdentifier;

- (BOOL)trustsPlugIn:(B7PlugIn *)thePlugIn;
- (BOOL)unloadPlugIn:(B7PlugIn *)thePlugIn;

@end
