//
//  GCKeychain.h
//  GCFoundation
//
//  Created by Georg C. Brückmann on 04.11.05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//
//  Based on AGKeychain by Adam Gerson  <agerson@mac.com>
//

#import <Cocoa/Cocoa.h>
#import <Security/Security.h>
#import <CoreFoundation/CoreFoundation.h>


@interface GCKeychain : NSObject {

}

+ (GCKeychain *)loginKeychain;

- (BOOL)itemExistsWithName:(NSString *)keychainItemName andKind:(NSString *)keychainItemKind forUsername:(NSString *)username;
- (BOOL)deleteItemWithName:(NSString *)keychainItemName andKind:(NSString *)keychainItemKind forUsername:(NSString *)username;
- (BOOL)setPassword:(NSString *)password forItemWithName:(NSString *)keychainItemName andKind:(NSString *)keychainItemKind forUsername:(NSString *)username;
- (BOOL)modifyItemWithName:(NSString *)keychainItemName andKind:(NSString *)keychainItemKind forUsername:(NSString *)username newPassword:(NSString *)newPassword;
- (BOOL)addItemWithName:(NSString *)keychainItemName andKind:(NSString *)keychainItemKind forUsername:(NSString *)username password:(NSString *)password;
- (BOOL)getUsername:(NSString **)theUsernameP andPassword:(NSString **)thePasswordP fromItemWithName:(NSString *)keychainItemName andKind:(NSString *)keychainItemKind;
- (NSString *)getPasswordFromItemWithName:(NSString *)keychainItemName andKind:(NSString *)keychainItemKind forUsername:(NSString *)username;
- (NSString *)getPasswordFromSecKeychainItemRef:(SecKeychainItemRef)item;

@end
