//
//  NSDictionary+GCFoundationEnhancements.h
//  GCFoundation
//
//  Created by Georg C. Brückmann on 29.04.06.
//  Copyright 2006 Georg C. Brückmann. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSDictionary (GCFoundationEnhancements)

+ (NSDictionary *)dictionaryNamed:(NSString *)aName;

+ (NSDictionary *)dictionaryNamed:(NSString *)aName fileType:(NSString *)aType;

- (id)objectOfClass:(Class)theClass forKey:(NSString *)theKey;
- (BOOL)boolForKey:(NSString *)key;
- (NSInteger)integerForKey:(NSString *)theKey;
- (NSUInteger)unsignedIntegerForKey:(NSString *)theKey;
- (double)doubleForKey:(NSString *)theKey;
- (float)floatForKey:(NSString *)theKey;
- (NSSize)sizeValueForKey:(NSString *)theKey;
- (NSString *)stringForKey:(NSString *)theKey;
- (SEL)selectorValueForKey:(NSString *)theKey;
- (void *)pointerValueForKey:(NSString *)theKey;

+ (id)dictionaryWithVariableArgumentList:(va_list)theList;

@end
