//
//  NSFileManager+GCFoundationEnhancements.h
//  GCFoundation
//
//  Created by Georg C. Brückmann on 08.11.05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//


@interface NSFileManager (GCFoundationEnhancements)

- (BOOL)getFSRef:(FSRef *)fsRefP forPath:(NSString *)thePath;

- (BOOL)fileVisibleAtPath:(NSString *)aPath;

- (unsigned long long)fileSizeAtPath:(NSString *)aPath;

- (BOOL)createDirectoryStructure:(NSString *)path attributes:(NSDictionary *)attributes;

- (NSDictionary *)mergedDirectoryContentsFor:(NSString *)subdirectory inStandardDirectory:(NSSearchPathDirectory)standardDirectory ofDomains:(NSSearchPathDomainMask)domains;
- (NSDictionary *)mergedDirectoryContentsFor:(NSArray *)theDirectories;

- (BOOL)path:(NSString *)theChildPath isAChildOfPath:(NSString *)theParentPath;
- (BOOL)path:(NSString *)theChildPath isDescendantOfPath:(NSString *)theParentPath;

#define GCSystemLibraryPath						@"/System/Library"
#define GCAllUsersLibraryPath						@"/Library"
#define GCCurrentUserLibraryPath					[NSHomeDirectory stringByAppendingPathComponent:@"Library"]

#define GCMergedDirectoryContentsDefaultOptions											(0)
#define GCMergedDirectoryContentsExcludeHiddenFilesOption							(1)
- (id)mergedDirectoryContents:(BOOL)theUniqueFilenamesOnlyFlag inDirectoriesAtPaths:(NSArray *)thePaths options:(NSUInteger)theOptions;
- (id)mergedDirectoryContents:(BOOL)theUniqueFilenamesOnlyFlag forSubdirectory:(NSString *)theSubdirectory inStandardDirectory:(NSSearchPathDirectory)theStandardDirectory ofDomains:(NSSearchPathDomainMask)theDomains options:(NSUInteger)theOptions;
- (NSArray *)pathsOfSubdirectory:(NSString *)theSubdirectory inStandardDirectories:(NSSearchPathDirectory)theStandardDirectory ofDomains:(NSSearchPathDomainMask)theDomains;

@end
