//
//  NSUserDefaults+TypedAccessors.h
//
//  Created by Georg C. Brückmann on 07.12.05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <TargetConditionals.h>


@interface NSUserDefaults (TypedAccessors)

- (NSUInteger)unsignedIntegerForKey:(NSString *)theKey;
- (void)setUnsignedInteger:(NSUInteger)theValue forKey:(NSString *)theKey;

#if TARGET_OS_IPHONE
- (UIColor *)colorForKey:(NSString *)theKey;
- (void)setColor:(UIColor *)theColor forKey:(NSString *)theKey;
#else
- (NSColor *)colorForKey:(NSString *)theKey;
- (void)setColor:(NSColor *)theColor forKey:(NSString *)theKey;
#endif

- (BOOL)toggleBoolForKey:(NSString *)key;

- (void)setObject:(id)value
		   forKey:(NSString *)key inDictionaryForKey:(NSString *)dictionaryDefaultName;
- (void)removeObjectForKey:(NSString *)key
	  fromDictionaryForKey:(NSString *)dictionaryDefaultName;

- (id)fontForKey:(NSString *)key;
- (void)setFont:(id)font
			forKey:(NSString *)key;

@end
