//
//  NSWorkspace+GCFoundationAdditions.h
//  GCFoundation
//
//  Created by Georg C. Brückmann on 23.12.05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//


@interface NSWorkspace (GCFoundationAdditions)

@property(readonly, copy)	NSString	*computerName;
@property(readonly, copy)	NSData	*computerSerialNumber;
@property(readonly, copy)	NSString	*computerSerialNumberString;

- (BOOL)openPreferencePaneWithBundleIdentifier:(NSString *)theIdentifier;

- (NSURL *)URLOfDefaultHandlerForURL:(NSURL *)theURL;
- (NSString *)nameOfDefaultHandlerForURL:(NSURL *)theURL;

@end


extern NSString	*const NSWorkspaceScreenDidLockNotification;
extern NSString	*const NSWorkspaceScreenDidUnlockNotification;


@interface NSWorkspace (ScreenLockStatus)

@property(readonly,
	getter=screenIsLocked)	BOOL	screenLocked;
@property(readwrite)			BOOL	requiresPasswordToStopScreenSaver;

- (void)beginObservingScreenLockStatus;

/* You should link against ScreenSaver.framework to get proper locking. */
- (void)lockScreen;

@end
