//
//  WMAuthenticationManager.h
//  Watchmac
//
//  Created by Georg C. on 14.02.09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "WMAuthenticationPanel.h"


typedef enum {
	WMAuthenticationMethodCustomPassword	= 0,
	WMAuthenticationMethodLoginPassword		= 1
} WMAuthenticationMethod;


typedef enum {
	WMAuthenticationManagerReturnCodeUserCancelled			= -1,
	WMAuthenticationManagerReturnCodeInvalidCredentials	= 0,
	WMAuthenticationManagerReturnCodeSuccess					= 1
} WMAuthenticationManagerReturnCode;


extern NSString	*const WMAuthenticationDidFailNotification;


@interface WMAuthenticationManager : NSObject <WMAuthenticationPanelDelegate> {
	WMAuthenticationMethod	authenticationMethod;
	WMAuthenticationPanel *authenticationPanel;
}

@property	WMAuthenticationMethod	authenticationMethod;

+ (WMAuthenticationManager *)defaultManager;


- (void)requireAuthenticationWithMessage:(NSString *)theMessage
											 prompt:(NSString *)thePrompt
									 parentWindow:(NSWindow *)theParentWindow
									modalDelegate:(id)theModalDelegate
								  didEndSelector:(SEL)theDidEndSelector;
- (void)requireAuthenticationWithMessage:(NSString *)theMessage
											 prompt:(NSString *)thePrompt
									modalDelegate:(id)theDelegate
								  didEndSelector:(SEL)theDidEndSelector;

- (BOOL)canChangeCredentialsForMethod:(WMAuthenticationMethod)theMethod;
- (BOOL)credentialsSetForMethod:(WMAuthenticationMethod)theMethod;
- (BOOL)changePassword:(NSString *)theNewPassword forAuthenticationMethod:(WMAuthenticationMethod)theAuthenticationMethod;
- (BOOL)verifyPassword:(NSString *)thePassword forAuthenticationMethod:(WMAuthenticationMethod)theAuthenticationMethod;

@end


@interface NSObject (WMAuthenticationManager_ModalDelegateAdditions)

- (void)authenticationManager:(WMAuthenticationManager *)authenticationManager
					 willShowPanel:(WMAuthenticationPanel *)panel;

@end
