//
//  WMAuthenticationPanel.h
//  Watchmac
//
//  Created by Georg C. on 09.08.08.
//  Copyright 2008 bloo7 (Georg C. Brückmann). All rights reserved.
//

#import <Cocoa/Cocoa.h>


typedef enum {
	WMAuthenticationPanelReturnCodeUserCancelled			= -1,
	WMAuthenticationPanelReturnCodeInvalidCredentials	= 0,
	WMAuthenticationPanelReturnCodeSuccess					= 1
} WMAuthenticationPanelReturnCode;


@class WMAuthenticationPanel;


@protocol WMAuthenticationPanelDelegate <NSObject>

@optional
- (BOOL)authenticationPanel:(WMAuthenticationPanel *)thePanel shouldAcceptPassword:(NSString *)thePassword forUsername:(NSString *)theUsername;

@end


@interface WMAuthenticationPanel : NSWindowController {
	NSString										*username;
	NSString										*password;
	NSString										*message;
	NSString										*title;
	NSString										*prompt;
	IBOutlet NSSecureTextField				*passwordField;
	IBOutlet NSObjectController			*editingController;
	IBOutlet NSButton							*okButton;
	NSSize										okButtonMinimumSize;
	IBOutlet NSButton							*cancelButton;
	id<WMAuthenticationPanelDelegate>	delegate;
}

@property(readwrite, copy)	NSString											*username;
@property(readwrite, copy)	NSString											*password;
@property(readwrite, copy)	NSString											*message;
@property(readwrite, copy)	NSString											*title;
@property(readwrite, copy)	NSString											*prompt;
@property(readwrite, assign)	id<WMAuthenticationPanelDelegate>	delegate;

- (WMAuthenticationPanelReturnCode)runModal;
- (void)beginSheetModalForWindow:(NSWindow *)theParentWindow modalDelegate:(id)theModalDelegate didEndSelector:(SEL)theDidEndSelector contextInfo:(void *)theContextInfo;

- (IBAction)ok:(id)theSender;
- (IBAction)cancel:(id)theSender;
@property(readonly, nonatomic, assign) NSButton *cancelButton;

@end
