//
//  WMPlugInDefaults.h
//  Watchmac
//
//  Created by Georg C. on 08.11.08.
//  Copyright 2008 bloo7 (Georg C. Brückmann). All rights reserved.


@interface WMPlugInDefaults : NSObject {
	NSMutableSet			*knownKeys;
	NSMutableDictionary	*cachedObjects;
	NSUInteger				ignoreChangeNotificationsCount;
}

- (id)objectForKey:(NSString *)theKey;
- (id)objectForUndefinedKey:(NSString *)theKey;
- (void)setObject:(id)theValue forKey:(NSString *)theKey;

- (void)registerKey:(NSString *)theKey;
- (void)cacheObject:(id)theValue forKey:(NSString *)theKey;
- (id)cachedObjectForKey:(NSString *)theKey;

- (void)ignoreChangeNotifications;
- (BOOL)respectChangeNotifications;

- (NSString *)stringForKey:(NSString *)theKey;
- (NSArray *)arrayForKey:(NSString *)theKey;
- (NSData *)dataForKey:(NSString *)theKey;
- (NSDictionary *)dictionaryForKey:(NSString *)theKey;
- (float)floatForKey:(NSString *)theKey;
- (NSInteger)integerForKey:(NSString *)theKey;
- (BOOL)boolForKey:(NSString *)theKey;

- (void)setBool:(BOOL)value forKey:(NSString *)theKey;

@end
