//
//  WMRecordedInfringement.h
//  Watchmac
//
//  Created by Georg C. on 30.07.08.
//  Copyright 2008 Georg C. Brückmann (bloo7). All rights reserved.
#import "WMInfringement.h"


@class GCCamera;
@protocol GCCameraDelegate;
@class WMInfringementHistory;
@class CSequenceGrabber;


@interface WMRecordedInfringement : WMInfringement <NSCoding> {
	NSMutableArray						*cameraSnapshots;
	NSImage								*cameraSnapshot;
	BOOL									reviewed;
	NSString								*notes;
	/*__weak*/ WMInfringementHistory	*history;
	NSInvocation						*didFinishTakingSnapshotsInvocation;
	CSequenceGrabber					*sequenceGrabber;
	NSTimer 								*snapshotGrabTimer;
	NSDictionary						*environmentalSnapshot;
}

@property(readonly, copy)		NSString								*localizedExplanatoryMessage;
@property(readonly, copy)		NSString								*localizedName;
@property(readwrite, copy)		NSArray								*cameraSnapshots;
@property(readwrite, assign,
	getter=hasBeenReviewed)		BOOL									reviewed;
@property(readwrite, copy)		NSString								*notes;
@property(readonly, retain)	NSImage								*icon;
@property(readwrite, assign)	/*__weak*/ WMInfringementHistory	*history;
@property(readwrite, retain)	NSDictionary						*environmentalSnapshot;


- (void)createEnvironmentalSnapshot;

- (void)addCameraSnapshot:(NSImage *)theSnapshot;
- (void)removeCameraSnapshot:(NSImage *)theSnapshot;

+ (NSImage *)iconForInfringementName:(NSString *)theInfringementName;

@end
