//
//  WMUserNotificationManager.h
//  Watchmac
//
//  Created by Georg C. on 18.06.08.
//  Copyright 2008 bloo7 (Georg C. Brückmann). All rights reserved.
//

#import <Cocoa/Cocoa.h>


@protocol GrowlApplicationBridgeDelegate;


@interface WMUserNotificationCenter : NSObject {
	BOOL				notificationsEnabled;
	BOOL				dispatchNotificationsToGrowl;
	NSMutableArray	*registeredNotificationNames;
	NSInteger						screenFlashCount;
	NSTimer							*screenFlashTimer;
	NSMutableSet					*screenFlashWindows;
}

@property(readwrite, assign,
	getter=areNotificationsEnabled)	BOOL	notificationsEnabled;
@property(readwrite, assign)			BOOL	dispatchNotificationsToGrowl;
@property(readonly, assign,
	getter=isGrowlInstalled)	BOOL		growlInstalled;

+ (WMUserNotificationCenter *)defaultCenter;

- (void)postNotificationName:(NSString *)theNotificationName identifier:(NSString *)theUniqueIdentifier title:(NSString *)theTitle message:(NSString *)theMessage sticky:(BOOL)sticky;

- (BOOL)registerNotificationName:(NSString *)theNotificationName;

- (void)flashScreen:(BOOL)flash count:(NSInteger)theCount;

@end
